/* Check Block Length of Magnetic Tape on UNIX system         */
/*                                 Copyright(c)1990 by T.Toda */
/* Original Version with submodules controlling BIOS directly */
/*                      has been coded by T.Toda in 1987,1988 */
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/mtio.h>

#define	BUFSIZE	65535

static	unsigned char	buffer[BUFSIZE];
static	int	fhd;
static	struct	mtop	mtopbuf;

char	*getenv();
void	report();

void	main(argc,argv,envp)
int	argc;
char	*argv[], *envp[];
{
	char	*devname;
	unsigned	len, len0 = 0, block = 0, block0, file = 0;

	if( argc > 2 ){
		fputs(argv[0],stdout);
		fputs(" : too many arguments\n",stdout);
		exit(8);
	}
	else if( argc == 2 ){
		devname = argv[1];
	}
	else{
		devname = getenv("TAPE");
		if( devname == NULL )devname = DEFTAPE;
	}

	fhd = open(devname,O_RDONLY);
	if( fhd == -1 ){
		fputs(devname,stdout);
		fputs(" : Device Open Error\n",stdout);
		exit(16);
	}
	mtopbuf.mt_count = 1;
	mtopbuf.mt_op = MTREW;
	ioctl(fhd,MTIOCTOP,&mtopbuf);
	
	for(;;){
		block++;
		if( len = read(fhd,buffer,BUFSIZE) ){
			if( len0 ){
				if( len != len0 ){
					report(block0,block,len0);
					block0 = block;
				}
			}
			else{
				printf("File No. %d\n",file++); 
				block0 = block;
			}
		}
		else{
			if( len0 ){
				report(block0,block,len0);
				block = 0;
			}
			fputs("## Tape Mark Block ##\n",stdout);
			if( len0 == 0 ){
				mtopbuf.mt_count = 1;
				mtopbuf.mt_op = MTREW;
				ioctl(fhd,MTIOCTOP,&mtopbuf);
				exit(0);
			}
		}
		len0 = len;
	}
}

static	void	report(block0,block,len)
unsigned	block0, block, len;
{
	block--;

	printf("  Block No.%6u ",block0);
	printf(( block == block0) ? "        " : " -%6u",block);
	printf(" : Length =%6u\n",len);
}
